package com.google.gwt.sample.contacts.client.view;

import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.HasClickHandlers;
import com.google.gwt.sample.contacts.client.presenter.EditContactPresenter;
import com.google.gwt.uibinder.client.UiBinder;
import com.google.gwt.uibinder.client.UiField;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HasValue;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.Widget;

public class EditContactView extends Composite implements
		EditContactPresenter.Display {
	
	// Annotation can be used to change the name of the associated xml file
	// @UiTemplate("EditContactView.ui.xml")
	interface MyUiBinder extends UiBinder<Widget, EditContactView> {
	}

	private static MyUiBinder uiBinder = GWT.create(MyUiBinder.class);

	@UiField TextBox firstName;
	@UiField TextBox lastName;
	@UiField TextBox emailAddress;
	@UiField Button saveButton;
	@UiField Button cancelButton;

	public EditContactView() {
		initWidget(uiBinder.createAndBindUi(this));
	}

	public HasValue<String> getFirstName() {
		return firstName;
	}

	public HasValue<String> getLastName() {
		return lastName;
	}

	public HasValue<String> getEmailAddress() {
		return emailAddress;
	}

	public HasClickHandlers getSaveButton() {
		return saveButton;
	}

	public HasClickHandlers getCancelButton() {
		return cancelButton;
	}

	public Widget asWidget() {
		return this;
	}
}
